---

stages:
  - build

variables:
  GIT_MAX_COMMIT: '1'
  GIT_MAIN_BRANCH: 'main'

# yamllint disable rule:line-length
.git-max-commits-script: &git-max-commits-script |
  # BEGSCRIPT
  echo "🕵️  Checking that we have less than ${GIT_MAX_COMMIT} in the branch"
  git fetch --quiet
  COMMON_ANCESTOR=$(git merge-base HEAD "origin/${GIT_MAIN_BRANCH}")
  NB_COMMITS=$(git rev-list --count "${COMMON_ANCESTOR}..HEAD")
  if [ "${NB_COMMITS}" -gt "${GIT_MAX_COMMIT}" ]
  then
    echo "😢 the number of your commits (${NB_COMMITS}) is greater than allowed (${GIT_MAX_COMMIT})"
    exit 1
  fi
  echo "🙂 All good!"
  # ENDSCRIPT
# yamllint enable rule:line-length

lint:git:max-commits:
  stage: build
  image:
    name: bitnami/git
  before_script:
    - git config --global --add safe.directory "${CI_PROJECT_DIR}"
  script:
    - *git-max-commits-script
  rules:
    - if:
        '$GIT_MAX_COMMITS_CHECK_DISABLED == "true" || $JOBS_DISABLED == "true"'
      when: never
    - if: '$CI_COMMIT_MESSAGE =~ /skip-maxcommits/'
      when: never
    - if: $CI_MERGE_REQUEST_ID
